//##############################################################################
//    	filename:        	lcd_lib_test_main.c
//
//     	main file LCD_LIB test project
//
//##############################################################################
//
//      Author:            	V.SchK
//      Company:        	THU
//
//      Revision:           2.0
//      Date:               Sep. 2019
//     	Assembled using     xc8 2.00+ C99
//
//   	todo	- add comments ;-)
//             	-
//
//##############################################################################

#include <xc.h>           // XC8 compiler

#include "lcd_lib_test.h"
#include "LCD_lib_busy.h"


//--- P R I V A T E   P R O T O T Y P E S --------------------------------------
void display(void);
void __init(void);

//#pragma udata
unsigned char displayTODO;
unsigned cntButton = 0;
char btnText[] = "Btn ?";

//##############################################################################
// Function:        void __main(void)
//						called from the startup code
// PreCondition:    None
// Input:
// Output:
// Side Effects:
// Overview:
//##############################################################################
void main() {

    __init();
    
    LCD_ConstTextOut(0,0,"20.09.19");
    LCD_TextOut(1,0,btnText);
    LCD_Command(DISPLAY_CTRL + DISPLAY_ON + BLINK_ON);// + CURSOR_ON );
    LCD_SetCursor(1,3);

    while (1) {
        if(BUTTON_PRESSED){
            while(BUTTON_PRESSED){;}
            cntButton++;
            displayTODO = 1;
        }

        if (displayTODO) {
            display();
            displayTODO = 0;
        }
    }
}



//##############################################################################
// Function:        void display(void)
//
// PreCondition:    None
// Input:
// Output:
// Side Effects:
// Overview:
//##############################################################################

void display() {
    LCD_ValueOut(1,4,cntButton);
    LCD_SetCursor(1,3);
}



//##############################################################################
// Function:        void __init(void)
//
// PreCondition:    None
// Input:
// Output:
// Side Effects:
// Overview:
//##############################################################################

void __init(void)
{
#if _XTAL_FREQ == 4000000
  #if defined(__18F25K22)
    OSCCON = 0x50; // 4 MHz internal clock
  #else
    OSCCON = 0x60; // 4 MHz internal clock for 4550/4520
    ADCON1 = 0xFF;  // pins digital IO
  #endif
#else
    #error "Please define _XTAL_FREQ in lcd_config.h"
#endif
    
    displayTODO = 0;

    LCD_On();
    LCD_Init();

    BUTTON_TRI = INPUT_PIN;
}